#include <iostream>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long n,q;
    cin >> n >> q;
    long long a[n+1],r[q+1];
    for(long long i=1;i<=n;i++){
        cin >> a[i];

    }
    for(long long i=1;i<=q;i++){
        long long l, d;
        cin >> l >> d;
        long long minimum=10000000;
        for(long long j=l;j<=d;j++){
            if(a[j]<minimum){
                minimum=a[j];
            }
            if(minimum==0){
                r[i]=0;
            }else{
                r[i]=a[l];
                for(long long j=l+1;j<=d;j++){
                    r[i]=r[i] & a[j];
                }
            }
        }

    }
    for(long long i=1;i<=q;i++){
        cout << r[i] << endl;
    }
    return 0;
}